<template>
  <div>
    <div class="_filters _filters--no-top">
      <div class="_filters__section">
        <div class="_filters__section__title">{{ $t('js.garden.coordination.group_by') }}</div>
        <div>
          <rui-toolbar>
            <rui-button :caption="$t('js.garden.coordination.group_by_patch')" :active="groupBy === 'patch'" @click="groupBy = 'patch'" />
            <rui-button :caption="$t('js.garden.coordination.group_by_resource')" :active="groupBy === 'resource'" @click="groupBy = 'resource'" />
            <rui-button :caption="$t('js.garden.coordination.no_group')" :active="groupBy === null" @click="groupBy = null" />
          </rui-toolbar>
        </div>
      </div>

      <div class="_filters__section">
        <div class="_filters__section__title">{{ $t('generic.date') }}</div>
        <div>
          <rui-toolbar :label="reference.getFullYear().toString()">
            <rui-button icon="caret-left" :title="$t('js.garden.coordination.back')" @click="shiftMonth(-1)" />
            <rui-button :caption="$t('js.garden.coordination.today')" @click="resetDate" />
            <rui-button icon="caret-right" :title="$t('js.garden.coordination.forward')" @click="shiftMonth(1)" />
          </rui-toolbar>
        </div>
      </div>
      <div class="_filters__section">
        <div class="_filters__section__title">{{ $t('js.generic.others') }}</div>
        <label><input v-model="showEmptyPatches" type="checkbox"> {{ $t('js.coordination.show_empty_patches') }}</label>
      </div>

      <div class="_filters__spring" />

      <rui-help-button>
        <gpa-months-graphs-legend />
      </rui-help-button>
    </div>

    <div v-if="groupBy === 'patch'">
      <rui-empty v-if="patches.length === 0" :content="$t('js.coordination.no_patch_to_display')" />
      <template v-else>
        <div v-for="patch in patches" :key="patch.id">
          <div class="-flex -gap _container -mtd">
            <h2 class="-mv0">{{ patch.displayName }}</h2>
            <rui-button icon="plus" variant="creative" @click="addElementInPatch(patch)" />
          </div>
          <gpa-months-graphs :elements="patchElements(patch)"
                             :reference="reference"
                             title-format="resource"
                             :empty-message="$t('js.coordination.empty_patch')" />
        </div>
      </template>
    </div>
    <div v-else-if="groupBy === 'resource'">
      <rui-empty v-if="resources.length === 0" :content="$t('js.coordination.no_element_to_display')" />
      <template v-else>
        <div v-for="resource in resources" :key="resource.id">
          <div class="-flex -gap _container -mtd">
            <h2 class="-mv0">{{ resource.name }}</h2>
            <rui-button icon="plus" variant="creative" @click="addResourceSomewhere(resource)" />
          </div>
          <gpa-months-graphs :elements="resourceElements(resource)" :reference="reference" title-format="patch" />
        </div>
      </template>
    </div>
    <div v-else>
      <rui-empty v-if="elements.length === 0" :content="$t('js.coordination.no_element_to_display')" />
      <template v-else>
        <gpa-months-graphs :elements="elements" :reference="reference" />
      </template>
    </div>
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiHelpButton from '@experiments-labs/rise_ui/src/components/HelpButton/HelpButton.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'

import GpaMonthsGraphs from './Elements/_MonthsGraphs.vue'
import GpaMonthsGraphsLegend from './Elements/_MonthsGraphsLegend.vue'

/**
 * @typedef {import('../../../classes/models/Element')} Element
 * @typedef {import('../../../classes/models/Patch')} Patch
 * @typedef {import('../../../classes/models/Resource')} Resource
 */

export default {
  name: 'GpaCoordination',
  components: { RuiEmpty, RuiHelpButton, RuiButton, RuiToolbar, GpaMonthsGraphsLegend, GpaMonthsGraphs },
  data () {
    return {
      reference: new Date(),
      groupBy: 'patch',
      showEmptyPatches: true,
    }
  },
  computed: {
    /** @type {Element[]} */
    elements () {
      return this.$store.getters.elements.filter((e) => e.patchId !== null && !e.isRemoved)
        .sort((a, b) => a.displayName.localeCompare(b.displayName))
    },
    /** @type {Patch[]} */
    patches () {
      if (this.showEmptyPatches) return this.$store.getters.patches

      const ids = this.elements
        .map(e => e.patchId)
        .filter((value, index, self) => self.indexOf(value) === index)
      return this.$store.getters.patchesByIds(ids)
    },
    /** @type {Resource[]} */
    resources () {
      const ids = this.elements
        .map(e => e.resourceId)
        .filter((value, index, self) => self.indexOf(value) === index)
      return this.$store.getters.resources.filter((r) => ids.includes(r.id))
    },
  },
  methods: {
    resetDate () { this.reference = new Date() },
    shiftMonth (amount) {
      const date = new Date(this.reference)
      date.setMonth(date.getMonth() + amount)
      this.reference = date
    },
    patchElements (patch) {
      return this.elements.filter(e => e.patchId === patch.id)
    },
    resourceElements (resource) {
      return this.elements.filter(e => e.resourceId === resource.id)
        .sort((a, b) => {
          const aDate = a.implantedAt || a.implantationPlannedFor
          const bDate = b.implantedAt || b.implantationPlannedFor
          return aDate - bDate
        })
    },
    addElementInPatch (patch) {
      this.$emitBus('show-patch-resource-picker', patch)
    },
    addResourceSomewhere (resource) {
      this.$emitBus('show-resource-patch-picker', (patch) => {
        const payload = { resource_id: resource.id, patch_id: patch.id }
        this.$store.dispatch('createElement', { payload })
          // Hide the picker
          .then(() => { this.$emitBus('show-resource-patch-picker', null) })
      })
    },
  },
}
</script>
